/*: TAVL_SDT.C	TAVL Tree library    Version 3.01   6-feb-93
 *: Prototype:	int tavl_setdata(TAVL_treeptr, TAVL_nodeptr p, void *item)
 *: Returns:	non-zero if insufficient memory to complete operation
 *:		OR key_of(item) != key_of(p's data)
 *: Purpose:	Change data in existing node.
 *
 *  Released to the PUBLIC DOMAIN
 *
 *  Author:		    Bert C. Hughes
 *			    200 N.Saratoga
 *			    St.Paul, MN 55104
 *			    Compuserve 71211,577
 */

#include "tavlpriv.h"

int tavl_setdata(TAVL_treeptr tree, TAVL_nodeptr p, void *item)
{
    void *temp;

    if (Is_Head(p)) return TAVL_ILLEGAL_OP;

    if ((*tree->cmp)((*tree->key_of)(p->dataptr),(*tree->key_of)(item)))
	return TAVL_ILLEGAL_OP;  /* Don't allow identifier to change! */

    if (!(temp = (*tree->make_item)(item))) return TAVL_NOMEM;

    (*tree->free_item)(p->dataptr);

    p->dataptr = temp;

    return TAVL_OK;
}
